SystemOrganization addCategory: #'NXTalk-Kernel'!
SystemOrganization addCategory: #'NXTalk-Building'!
SystemOrganization addCategory: #'NXTalk-Collections'!

!String methodsFor: '*nxtalk' stamp: 'mab 3/11/2008 01:09'!
printNl
	Transcript show: self; cr.! !

RBProgramNodeVisitor subclass: #NXTCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:36'!
byteCodes
	^ Dictionary new
		add: #halt -> 0;
		add: #dup -> 1;
		add: #pushLocal -> 2;
		add: #pushArgument -> 3;
		add: #pushField -> 3;
		add: #pushBlock -> 4;
		add: #pushConstant -> 5;
		add: #pushGlobal -> 6;
		add: #pop -> 7;
		add: #popLocal -> 8;
		add: #popArgument -> 9;
		add: #popField -> 10;
		add: #send -> 11;
		add: #superSend -> 12;
		add: #returnLocal -> 13;
		add: #returnNonLocal -> 14;
		yourself! !

!NXTCompiler methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:19'!
compileMethod: methodString
	| ast |
	ast := RBParser parseMethod: methodString.
	self visitNode: ast.! !

Object subclass: #NXTImage
	instanceVariableNames: 'objects specialObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/25/2008 23:50'!
addObject: anNXTObject
	^  self objects add: anNXTObject! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 22:57'!
initialize
	objects := OrderedCollection new.
	specialObjects := Dictionary new.! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/25/2008 23:38'!
metaclass
	^ self specialObjects at: #metaclass! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/25/2008 23:38'!
metaclass: aValue
	^ self specialObjects at: #metaclass put: aValue! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/20/2008 03:18'!
nil
	^ self specialObjects at: #nil! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/20/2008 03:18'!
nil: aValue
	^ self specialObjects at: #nil put: aValue! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
objects
	^ objects! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
objects: anObject
	objects := anObject! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
specialObjects
	^ specialObjects! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
specialObjects: anObject
	specialObjects := anObject! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/25/2008 23:25'!
systemDictionary
	^ self specialObjects at: #systemDictionary! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/25/2008 23:25'!
systemDictionary: aValue
	^ self specialObjects at: #systemDictionary put: aValue! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 2/25/2008 23:01'!
writeHeaderTo: aByteStream
	aByteStream int16: 16r4242.
	aByteStream int16: self objects size.! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 2/25/2008 22:48'!
writeObjectsTo: aByteStream
	! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 2/25/2008 22:49'!
writeSpecialObjectsTo: aByteStream! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 2/25/2008 22:22'!
writeToStream: aByteStream
	self writeHeaderTo: aByteStream.
	self writeObjectsTo: aByteStream.
	self writeSpecialObjectsTo: aByteStream.! !

Object subclass: #NXTImageBuilder
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageBuilder class methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:52'!
standardCategories
	^ #('NXTalk-Kernel' 'NXTalk-Collections')! !

!NXTImageBuilder class methodsFor: 'as yet unclassified' stamp: 'mab 2/26/2008 00:06'!
systemClasses
	^ #(objectClass nilClass classClass arrayClass symbolClass methodClass integerClass bigintegerClass frameClass stringClass doubleClass)! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:54'!
compileClass: aClass
	! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 03:00'!
compileClasses
	self class standardCategories do: [ :category |
		(Smalltalk organization listAtCategoryNamed: category) do: [ :class |
			self compileClass: class ]].! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:53'!
createMetaclasses
	| metaclass |
	metaclass := self newClass.
	metaclass nxtClass: self newClass.
	"Metaclass class class = Metaclass"
	metaclass nxtClass nxtClass: metaclass.
	^ metaclass! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/26/2008 00:24'!
createSpecialObjects
	self image nil: self newObject.
	self image metaclass: self createMetaclasses.
	self createSystemClasses.
	self image nil nxtClass: (self image specialObjects at: #nilClass).
	self initializeSystemClasses.! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 03:06'!
createStandardImage
	self image: NXTImage new.
	self createSpecialObjects.
	self compileClasses.! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/26/2008 00:06'!
createSystemClasses
	self class systemClasses do: [ :symbol |
		self image specialObjects at: symbol put: self newSystemClass ].
	! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 02:50'!
image
	^ image! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 02:50'!
image: anObject
	image := anObject! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/26/2008 00:39'!
initializeSystemClass: classSymbol superclass: superclassSymbol name: nameSymbol
	| class |
	class := self image specialObjects at: classSymbol.
	class nxtSuperclass: (self image specialObjects at: superclassSymbol).
	(self image specialObjects at: #Smalltalk) at: nameSymbol put: class.! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/26/2008 01:00'!
initializeSystemClasses
	self initializeSystemClass: #objectClass superclass: #nil name: #Object.
	self initializeSystemClass: #classClass superclass: #objectClass name: #Class.
	self initializeSystemClass: #metaclass superclass: #classClass name: #Metaclass.
	self initializeSystemClass: #nilClass superclass: #objectClass name: #UndefinedObject.
	self initializeSystemClass: #arrayClass superclass: #objectClass name: #Array.
	self initializeSystemClass: #methodClass superclass: #arrayClass name: #Method.
	self initializeSystemClass: #symbolClass superclass: #objectClass name: #Symbol.! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:52'!
newClass
	^  self image addObject: NXTImageClass new! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:52'!
newObject
	^  self image addObject: NXTImageObject new! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:56'!
newSystemClass
	| systemClass |
	systemClass := self newClass.
	systemClass nxtClass: self newClass.
	systemClass nxtClass nxtClass: self image metaclass.
	^ systemClass! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:36'!
objectForClass: anNXTClass
	| class |
	class := NXTImageClass new.
	class nxtClass: self newMetaclass.
	
	^ class! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:17'!
specialObjects
	^ self image specialObjects! !

Object subclass: #NXTImageObject
	instanceVariableNames: 'nxtClass instanceVariables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

NXTImageObject subclass: #NXTImageClass
	instanceVariableNames: 'instanceVariableNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageObject methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:05'!
initialize
	instanceVariables := OrderedCollection new.! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:03'!
instanceVariables
	^ instanceVariables! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:03'!
instanceVariables: anObject
	instanceVariables := anObject! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:04'!
nxtClass
	^ nxtClass! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:04'!
nxtClass: anObject
	nxtClass := anObject! !

Object subclass: #NXTObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTBoolean subclass: #NXTFalse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTBoolean subclass: #NXTTrue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Collections'!

NXTObject subclass: #NXTCompiledMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 3/11/2008 01:09'!
printNl
	<primitive: 500>! !

NXTString subclass: #NXTSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

!NXTSystem methodsFor: 'as yet unclassified' stamp: 'mab 3/11/2008 00:57'!
run
	'Hello World!!' printNl.! !

NXTObject subclass: #NXTUndefinedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!
